diff --git a/hledger/hledger.info b/hledger/hledger.info
index 72d7ca26a..a8ba671c1 100644
--- a/hledger/hledger.info
+++ b/hledger/hledger.info
@@ -1,4 +1,4 @@
-This is hledger.info, produced by makeinfo version 6.0 from stdin.
+This is hledger.info, produced by makeinfo version 6.5 from stdin.
 
 
 File: hledger.info,  Node: Top,  Next: EXAMPLES,  Up: (dir)
@@ -201,7 +201,7 @@ by most hledger commands, run 'hledger -h'.
 '-p --period=PERIODEXP'
 
      set start date, end date, and/or reporting interval all at once
-     (overrides the flags above)
+     using period expressions syntax (overrides the flags above)
 '--date2'
 
      match the secondary date instead (see command help for other
@@ -232,6 +232,17 @@ by most hledger commands, run 'hledger -h'.
 
      convert amounts to their market value on the report end date (using
      the most recent applicable market price, if any)
+'--forecast'
+
+     generate forecast transactions from [periodic
+     transaction]((journal.html#periodic-transactions) rules.  Each
+     periodic transaction rule will generate forecast transactions,
+     beginning the day after the last recorded journal transaction, and
+     ending 6 months from today, or at the specified report end date.
+'--auto'
+
+     apply automated posting rules to modify transactions where
+     applicable (can combine with -forecast).
 
    When a reporting option appears more than once in the command line,
 the last one takes precedence.
@@ -339,15 +350,15 @@ be one of several other formats, listed below.  hledger detects the
 format automatically based on the file extension, or if that is not
 recognised, by trying each built-in "reader" in turn:
 
-Reader:     Reads:                             Used for file extensions:
----------------------------------------------------------------------------
-'journal'   hledger's journal format, also     '.journal' '.j'
-            some Ledger journals               '.hledger' '.ledger'
-'timeclock' timeclock files (precise time      '.timeclock'
+Reader:     Reads:                              Used for file extensions:
+----------------------------------------------------------------------------
+'journal'   hledger's journal format, also      '.journal' '.j'
+            some Ledger journals                '.hledger' '.ledger'
+'timeclock' timeclock files (precise time       '.timeclock'
             logging)
-'timedot'   timedot files (approximate time    '.timedot'
+'timedot'   timedot files (approximate time     '.timedot'
             logging)
-'csv'       comma-separated values (data       '.csv'
+'csv'       comma-separated values (data        '.csv'
             interchange)
 
    If needed (eg to ensure correct error messages when a file has the
@@ -950,7 +961,7 @@ default).  With query arguments, it counts only matched transactions.
 $ hledger activity --quarterly
 2008-01-01 **
 2008-04-01 *******
-2008-07-01
+2008-07-01 
 2008-10-01 **
 
 
@@ -1007,18 +1018,18 @@ An optional ; COMMENT may follow descriptions or amounts.
 If you make a mistake, enter < at any prompt to restart the transaction.
 To end a transaction, enter . when prompted.
 To quit, enter . at a date prompt or press control-d or control-c.
-Date [2015/05/22]:
+Date [2015/05/22]: 
 Description: supermarket
 Account 1: expenses:food
 Amount  1: $10
 Account 2: assets:checking
-Amount  2 [$-10.0]:
+Amount  2 [$-10.0]: 
 Account 3 (or . or enter to finish this transaction): .
 2015/05/22 supermarket
     expenses:food             $10
     assets:checking        $-10.0
 
-Save this transaction to the journal ? [y]:
+Save this transaction to the journal ? [y]: 
 Saved.
 Starting the next transaction (. or ctrl-D/ctrl-C to quit)
 Date [2015/05/22]: <CTRL-D> $
@@ -1082,6 +1093,14 @@ Show accounts and their balances.  Aliases: b, bal.
 
      Sort by amount (total row amount, or by average if that is
      displayed), instead of account name (in flat mode)
+'--budget'
+
+     Treat periodic transaction as definition of a budget.  Compare real
+     balances to budget balances and show percentage of budget consumed.
+'--show-unbudgeted'
+
+     When -budget is used, display accounts that do not have budget
+     defined
 
    The balance command displays accounts and balances.  It is hledger's
 most featureful and versatile command.
@@ -1131,6 +1150,7 @@ $ hledger balance -p 2008/6 expenses --no-total
 * Flat mode::
 * Depth limited balance reports::
 * Multicolumn balance reports::
+* Budgets::
 * Custom balance output::
 * Colour support::
 * Output destination::
@@ -1170,7 +1190,7 @@ $ hledger balance -N --depth 1
                   $1  liabilities
 
 
-File: hledger.info,  Node: Multicolumn balance reports,  Next: Custom balance output,  Prev: Depth limited balance reports,  Up: balance
+File: hledger.info,  Node: Multicolumn balance reports,  Next: Budgets,  Prev: Depth limited balance reports,  Up: balance
 
 4.4.3 Multicolumn balance reports
 ---------------------------------
@@ -1185,15 +1205,15 @@ report, showing different information:
 
      $ hledger balance --quarterly income expenses -E
      Balance changes in 2008:
-
-                        ||  2008q1  2008q2  2008q3  2008q4
+     
+                        ||  2008q1  2008q2  2008q3  2008q4 
      ===================++=================================
-      expenses:food     ||       0      $1       0       0
-      expenses:supplies ||       0      $1       0       0
-      income:gifts      ||       0     $-1       0       0
-      income:salary     ||     $-1       0       0       0
+      expenses:food     ||       0      $1       0       0 
+      expenses:supplies ||       0      $1       0       0 
+      income:gifts      ||       0     $-1       0       0 
+      income:salary     ||     $-1       0       0       0 
      -------------------++---------------------------------
-                        ||     $-1      $1       0       0
+                        ||     $-1      $1       0       0 
 
   2. With '--cumulative': each column shows the ending balance for that
      period, accumulating the changes across periods, starting from 0 at
@@ -1201,15 +1221,15 @@ report, showing different information:
 
      $ hledger balance --quarterly income expenses -E --cumulative
      Ending balances (cumulative) in 2008:
-
-                        ||  2008/03/31  2008/06/30  2008/09/30  2008/12/31
+     
+                        ||  2008/03/31  2008/06/30  2008/09/30  2008/12/31 
      ===================++=================================================
-      expenses:food     ||           0          $1          $1          $1
-      expenses:supplies ||           0          $1          $1          $1
-      income:gifts      ||           0         $-1         $-1         $-1
-      income:salary     ||         $-1         $-1         $-1         $-1
+      expenses:food     ||           0          $1          $1          $1 
+      expenses:supplies ||           0          $1          $1          $1 
+      income:gifts      ||           0         $-1         $-1         $-1 
+      income:salary     ||         $-1         $-1         $-1         $-1 
      -------------------++-------------------------------------------------
-                        ||         $-1           0           0           0
+                        ||         $-1           0           0           0 
 
   3. With '--historical/-H': each column shows the actual historical
      ending balance for that period, accumulating the changes across
@@ -1219,15 +1239,15 @@ report, showing different information:
 
      $ hledger balance ^assets ^liabilities --quarterly --historical --begin 2008/4/1
      Ending balances (historical) in 2008/04/01-2008/12/31:
-
-                           ||  2008/06/30  2008/09/30  2008/12/31
+     
+                           ||  2008/06/30  2008/09/30  2008/12/31 
      ======================++=====================================
-      assets:bank:checking ||          $1          $1           0
-      assets:bank:saving   ||          $1          $1          $1
-      assets:cash          ||         $-2         $-2         $-2
-      liabilities:debts    ||           0           0          $1
+      assets:bank:checking ||          $1          $1           0 
+      assets:bank:saving   ||          $1          $1          $1 
+      assets:cash          ||         $-2         $-2         $-2 
+      liabilities:debts    ||           0           0          $1 
      ----------------------++-------------------------------------
-                           ||           0           0           0
+                           ||           0           0           0 
 
    Multi-column balance reports display accounts in flat mode by
 default; to see the hierarchy, use '--tree'.
@@ -1256,23 +1276,113 @@ each row.
 $ hledger balance -Q income expenses --tree -ETA
 Balance changes in 2008:
 
-            ||  2008q1  2008q2  2008q3  2008q4    Total  Average
+            ||  2008q1  2008q2  2008q3  2008q4    Total  Average 
 ============++===================================================
- expenses   ||       0      $2       0       0       $2       $1
-   food     ||       0      $1       0       0       $1        0
-   supplies ||       0      $1       0       0       $1        0
- income     ||     $-1     $-1       0       0      $-2      $-1
-   gifts    ||       0     $-1       0       0      $-1        0
-   salary   ||     $-1       0       0       0      $-1        0
+ expenses   ||       0      $2       0       0       $2       $1 
+   food     ||       0      $1       0       0       $1        0 
+   supplies ||       0      $1       0       0       $1        0 
+ income     ||     $-1     $-1       0       0      $-2      $-1 
+   gifts    ||       0     $-1       0       0      $-1        0 
+   salary   ||     $-1       0       0       0      $-1        0 
 ------------++---------------------------------------------------
-            ||     $-1      $1       0       0        0        0
+            ||     $-1      $1       0       0        0        0 
 
 # Average is rounded to the dollar here since all journal amounts are
 
 
-File: hledger.info,  Node: Custom balance output,  Next: Colour support,  Prev: Multicolumn balance reports,  Up: balance
+File: hledger.info,  Node: Budgets,  Next: Custom balance output,  Prev: Multicolumn balance reports,  Up: balance
 
-4.4.4 Custom balance output
+4.4.4 Budgets
+-------------
+
+The '--budget' flag will treat all [periodic
+transaction]((journal.html#periodic-transactions) in your journal as
+definition of the budget and allow you to compare real balances versus
+budgeted amounts.
+
+   For example, you can take average monthly expenses in the common
+expense categories to construct a minimal monthly budget:
+
+;; Budget
+~ monthly
+  income  $2000
+  expenses:food    $400
+  expenses:bus     $50
+  expenses:movies  $30
+  assets:bank:checking
+
+;; Two months worth of expenses
+2017-11-01
+  income  $1950
+  expenses:food    $396
+  expenses:bus     $49
+  expenses:movies  $30
+  expenses:supplies  $20
+  assets:bank:checking
+
+2017-12-01
+  income  $2100
+  expenses:food    $412
+  expenses:bus     $53
+  expenses:gifts   $100
+  assets:bank:checking
+
+   You can now compare real balances with budget:
+
+$ hledge balance -M --budget
+Balance changes in 2017/11/01-2017/12/31:
+
+                       ||                2017/11                  2017/12 
+=======================++=================================================
+ <unbudgeted>:expenses ||                    $20                     $100 
+ assets:bank:checking  || $-2445 [99% of $-2480]  $-2665 [107% of $-2480] 
+ expenses:bus          ||       $49 [98% of $50]        $53 [106% of $50] 
+ expenses:food         ||     $396 [99% of $400]      $412 [103% of $400] 
+ expenses:movies       ||      $30 [100% of $30]            0 [0% of $30] 
+ income                ||   $1950 [98% of $2000]    $2100 [105% of $2000] 
+-----------------------++-------------------------------------------------
+                       ||                      0                        0 
+
+   You can roll over unspent budgets to next period with '--cumulative':
+
+$ hledger balance -M --budget --cumulative
+Ending balances (cumulative) in 2017/11/01-2017/12/31:
+
+                       ||             2017/11/30               2017/12/31 
+=======================++=================================================
+ <unbudgeted>:expenses ||                    $20                     $120 
+ assets:bank:checking  || $-2445 [99% of $-2480]  $-5110 [103% of $-4960] 
+ expenses:bus          ||       $49 [98% of $50]      $102 [102% of $100] 
+ expenses:food         ||     $396 [99% of $400]      $808 [101% of $800] 
+ expenses:movies       ||      $30 [100% of $30]         $30 [50% of $60] 
+ income                ||   $1950 [98% of $2000]    $4050 [101% of $4000] 
+-----------------------++-------------------------------------------------
+                       ||                      0                        0
+
+   Adding '--show-unbudgeted' will allow you to see all the accounts for
+which budgets:
+
+$ hledger balance --budget --show-unbudgeted
+Balance changes in 2017/11/01-2017/12/31:
+
+                      ||                2017/11                  2017/12 
+======================++=================================================
+ assets:bank:checking || $-2445 [99% of $-2480]  $-2665 [107% of $-2480] 
+ expenses:bus         ||       $49 [98% of $50]        $53 [106% of $50] 
+ expenses:food        ||     $396 [99% of $400]      $412 [103% of $400] 
+ expenses:gifts       ||                      0                     $100 
+ expenses:movies      ||      $30 [100% of $30]            0 [0% of $30] 
+ expenses:supplies    ||                    $20                        0 
+ income               ||   $1950 [98% of $2000]    $2100 [105% of $2000] 
+----------------------++-------------------------------------------------
+                      ||                      0                        0 
+
+   For more examples and details, see Budgeting and Forecasting.
+
+
+File: hledger.info,  Node: Custom balance output,  Next: Colour support,  Prev: Budgets,  Up: balance
+
+4.4.5 Custom balance output
 ---------------------------
 
 In simple (non-multi-column) balance reports, you can customise the
@@ -1332,7 +1442,7 @@ may be needed to get pleasing results.
 
 File: hledger.info,  Node: Colour support,  Next: Output destination,  Prev: Custom balance output,  Up: balance
 
-4.4.5 Colour support
+4.4.6 Colour support
 --------------------
 
 The balance command shows negative amounts in red, if:
@@ -1343,7 +1453,7 @@ The balance command shows negative amounts in red, if:
 
 File: hledger.info,  Node: Output destination,  Next: CSV output,  Prev: Colour support,  Up: balance
 
-4.4.6 Output destination
+4.4.7 Output destination
 ------------------------
 
 The balance, print, register and stats commands can write their output
@@ -1356,7 +1466,7 @@ $ hledger balance -o FILE  # write to FILE
 
 File: hledger.info,  Node: CSV output,  Prev: Output destination,  Up: balance
 
-4.4.7 CSV output
+4.4.8 CSV output
 ----------------
 
 The balance, print and register commands can write their output as CSV.
@@ -2033,7 +2143,7 @@ Show some journal statistics.
 
 $ hledger stats
 Main journal file        : /src/hledger/examples/sample.journal
-Included journal files   :
+Included journal files   : 
 Transactions span        : 2008-01-01 to 2009-01-01 (366 days)
 Last transaction         : 2008-12-31 (2333 days ago)
 Transactions             : 5 (0.0 per day)
@@ -2264,129 +2374,131 @@ Node: OPTIONS3628
 Ref: #options3730
 Node: General options4046
 Ref: #general-options4171
-Node: Command options6490
-Ref: #command-options6641
-Node: Command arguments7039
-Ref: #command-arguments7193
-Node: Argument files7314
-Ref: #argument-files7465
-Node: Special characters7731
-Ref: #special-characters7884
-Node: Input files9303
-Ref: #input-files9439
-Node: Smart dates11402
-Ref: #smart-dates11543
-Node: Report start & end date12522
-Ref: #report-start-end-date12692
-Node: Report intervals13757
-Ref: #report-intervals13920
-Node: Period expressions14321
-Ref: #period-expressions14478
-Node: For example16523
-Ref: #for-example16666
-Node: Depth limiting18590
-Ref: #depth-limiting18727
-Node: Pivoting19069
-Ref: #pivoting19187
-Node: Cost20863
-Ref: #cost20971
-Node: Market value21089
-Ref: #market-value21224
-Node: Regular expressions22524
-Ref: #regular-expressions22660
-Node: QUERIES24021
-Ref: #queries24123
-Node: COMMANDS28090
-Ref: #commands28202
-Node: accounts29185
-Ref: #accounts29283
-Node: activity30276
-Ref: #activity30386
-Node: add30745
-Ref: #add30844
-Node: balance33502
-Ref: #balance33613
-Node: Flat mode36770
-Ref: #flat-mode36895
-Node: Depth limited balance reports37315
-Ref: #depth-limited-balance-reports37516
-Node: Multicolumn balance reports37936
-Ref: #multicolumn-balance-reports38145
-Node: Custom balance output42793
-Ref: #custom-balance-output42975
-Node: Colour support45068
-Ref: #colour-support45227
-Node: Output destination45400
-Ref: #output-destination45556
-Node: CSV output45826
-Ref: #csv-output45943
-Node: balancesheet46340
-Ref: #balancesheet46476
-Node: balancesheetequity48444
-Ref: #balancesheetequity48593
-Node: cashflow49382
-Ref: #cashflow49510
-Node: check-dates51422
-Ref: #check-dates51549
-Node: check-dupes51666
-Ref: #check-dupes51791
-Node: equity51928
-Ref: #equity52038
-Node: help52201
-Ref: #help52302
-Node: import53376
-Ref: #import53490
-Node: incomestatement54220
-Ref: #incomestatement54354
-Node: prices56307
-Ref: #prices56422
-Node: print56465
-Ref: #print56575
-Node: print-unique61421
-Ref: #print-unique61547
-Node: register61615
-Ref: #register61742
-Node: Custom register output66243
-Ref: #custom-register-output66372
-Node: register-match67669
-Ref: #register-match67803
-Node: rewrite67986
-Ref: #rewrite68103
-Node: stats68172
-Ref: #stats68275
-Node: tags69156
-Ref: #tags69254
-Node: test69490
-Ref: #test69574
-Node: ADD-ON COMMANDS69942
-Ref: #add-on-commands70052
-Node: Official add-ons71339
-Ref: #official-add-ons71479
-Node: api71566
-Ref: #api71655
-Node: ui71707
-Ref: #ui71806
-Node: web71864
-Ref: #web71953
-Node: Third party add-ons71999
-Ref: #third-party-add-ons72174
-Node: diff72309
-Ref: #diff72406
-Node: iadd72505
-Ref: #iadd72619
-Node: interest72702
-Ref: #interest72823
-Node: irr72918
-Ref: #irr73016
-Node: Experimental add-ons73094
-Ref: #experimental-add-ons73246
-Node: autosync73537
-Ref: #autosync73649
-Node: budget73888
-Ref: #budget74010
-Node: chart74076
-Ref: #chart74193
-Node: check74264
-Ref: #check74366
+Node: Command options6985
+Ref: #command-options7136
+Node: Command arguments7534
+Ref: #command-arguments7688
+Node: Argument files7809
+Ref: #argument-files7960
+Node: Special characters8226
+Ref: #special-characters8379
+Node: Input files9798
+Ref: #input-files9934
+Node: Smart dates11904
+Ref: #smart-dates12045
+Node: Report start & end date13024
+Ref: #report-start-end-date13194
+Node: Report intervals14259
+Ref: #report-intervals14422
+Node: Period expressions14823
+Ref: #period-expressions14980
+Node: For example17025
+Ref: #for-example17168
+Node: Depth limiting19092
+Ref: #depth-limiting19229
+Node: Pivoting19571
+Ref: #pivoting19689
+Node: Cost21365
+Ref: #cost21473
+Node: Market value21591
+Ref: #market-value21726
+Node: Regular expressions23026
+Ref: #regular-expressions23162
+Node: QUERIES24523
+Ref: #queries24625
+Node: COMMANDS28592
+Ref: #commands28704
+Node: accounts29687
+Ref: #accounts29785
+Node: activity30778
+Ref: #activity30888
+Node: add31248
+Ref: #add31347
+Node: balance34008
+Ref: #balance34119
+Node: Flat mode37548
+Ref: #flat-mode37673
+Node: Depth limited balance reports38093
+Ref: #depth-limited-balance-reports38294
+Node: Multicolumn balance reports38714
+Ref: #multicolumn-balance-reports38909
+Node: Budgets43598
+Ref: #budgets43745
+Node: Custom balance output47361
+Ref: #custom-balance-output47523
+Node: Colour support49616
+Ref: #colour-support49775
+Node: Output destination49948
+Ref: #output-destination50104
+Node: CSV output50374
+Ref: #csv-output50491
+Node: balancesheet50888
+Ref: #balancesheet51024
+Node: balancesheetequity52992
+Ref: #balancesheetequity53141
+Node: cashflow53930
+Ref: #cashflow54058
+Node: check-dates55970
+Ref: #check-dates56097
+Node: check-dupes56214
+Ref: #check-dupes56339
+Node: equity56476
+Ref: #equity56586
+Node: help56749
+Ref: #help56850
+Node: import57924
+Ref: #import58038
+Node: incomestatement58768
+Ref: #incomestatement58902
+Node: prices60855
+Ref: #prices60970
+Node: print61013
+Ref: #print61123
+Node: print-unique65969
+Ref: #print-unique66095
+Node: register66163
+Ref: #register66290
+Node: Custom register output70791
+Ref: #custom-register-output70920
+Node: register-match72217
+Ref: #register-match72351
+Node: rewrite72534
+Ref: #rewrite72651
+Node: stats72720
+Ref: #stats72823
+Node: tags73705
+Ref: #tags73803
+Node: test74039
+Ref: #test74123
+Node: ADD-ON COMMANDS74491
+Ref: #add-on-commands74601
+Node: Official add-ons75888
+Ref: #official-add-ons76028
+Node: api76115
+Ref: #api76204
+Node: ui76256
+Ref: #ui76355
+Node: web76413
+Ref: #web76502
+Node: Third party add-ons76548
+Ref: #third-party-add-ons76723
+Node: diff76858
+Ref: #diff76955
+Node: iadd77054
+Ref: #iadd77168
+Node: interest77251
+Ref: #interest77372
+Node: irr77467
+Ref: #irr77565
+Node: Experimental add-ons77643
+Ref: #experimental-add-ons77795
+Node: autosync78086
+Ref: #autosync78198
+Node: budget78437
+Ref: #budget78559
+Node: chart78625
+Ref: #chart78742
+Node: check78813
+Ref: #check78915
 
 End Tag Table
